package com.steerinfo.baseinfo.meterfilestorage.controller;

import com.steerinfo.baseinfo.meterfilestorage.mapper.MeterFileStorageMapper;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterfilestorage.model.MeterFileStorage;
import com.steerinfo.baseinfo.meterfilestorage.service.IMeterFileStorageService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.*;
import java.math.BigDecimal;

/**
 * MeterFileStorage RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-25 09:32
 * 类描述
 * 修订历史：
 * 日期：2022-01-25
 * 作者：generator
 * 参考：
 * 描述：MeterFileStorage RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterfilestorages")
public class MeterFileStorageController extends BaseRESTfulController {

    @Autowired
    IMeterFileStorageService meterFileStorageService;
    @Autowired
    MeterFileStorageMapper meterFileStorageMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterfilestorage:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterFileStorage> list = meterFileStorageService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterfilestorage:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterFileStorage> list = meterFileStorageService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterFileStorage对象创建")
    @ApiImplicitParam(name = "meterFileStorage", value = "详细实体meterFileStorage", required = true, dataType = "MeterFileStorage")
    //@RequiresPermissions("meterfilestorage:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterFileStorage model){
        if (model == null) {
            return failed("参数为空");
        }
        if (model.getFilePath() == null || "".equals(model.getFilePath())) {
            return failed("请上传文件后在进行新增操作");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String no = meterFileStorageMapper.getNewID(sdf.format(new Date()));
        model.setFileId(sdf.format(new Date()) + no);
        model.setCreateTime(new Date());
        model.setValidFlag("1");
        MeterFileStorage meterFileStorage = meterFileStorageService.add(model);
        return success(meterFileStorage);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterfilestorage:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterFileStorage meterFileStorage = meterFileStorageService.getById(id);
        return success(meterFileStorage);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterFileStorage信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterFileStorage", value = "详细实体meterFileStorage", required = true, dataType = "MeterFileStorage")
    })
    //@RequiresPermissions("meterfilestorage:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterFileStorage model){
        model.setId(id);
        MeterFileStorage meterFileStorage = meterFileStorageService.modify(model);
        return success(meterFileStorage);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterfilestorage:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterFileStorageService.delete(ids);
    	}
      return success();
    }
}
